$ = jQuery;

function onSettingsPopup() {
    // login section
    var $loginTextBox = $('.inputLogin').first();
    var $changeLoginBut = $('.changeLogin').last();
    var loginTextBoxTitle = $changeLoginBut.text();

    $loginTextBox.keyup(function (event) {
        if (event.keyCode == 13)
            $changeLoginBut.trigger('click');
        else {
            var prev = $loginTextBox.val();
            $loginTextBox.val(prev.replace(/[^a-z0-9_\-\.]/gi, ''));
        }
    });

    $changeLoginBut.click(function () {
        var login = $loginTextBox.val();

        if (!login.length) {
            $loginTextBox.focus();
            return;
        }

        if (login.length < 2) {
            EventInspector.error('Слишком короткий логин, мыслите шире!');
            $loginTextBox.focus();
            return;
        }

        if (!/^[a-zA-Z0-9_\-\.]{2,}$/.test(login)) {
            EventInspector.error('Некорректные символы в логине, попробуйте ещё раз!');
            $loginTextBox.focus();
            return;
        }

        $changeLoginBut.attr('disabled', 'disabled')
            .html('<i class="fa fa-circle-o-notch fa-spin"></i>');

        $.post(URLdir + 'handler/settings/changeLogin', {
            'login': login
        }, function (res) {
            res.success
                ? $changeLoginBut.text('Логин изменён!')
                : $changeLoginBut.text('Ошибка!').addClass('Error').removeAttr('disabled');

            setTimeout(function () {
                $changeLoginBut.removeAttr('disabled')
                    .text(loginTextBoxTitle)
                    .removeClass('Error');
            }, 1000);
        }, 'json');
    });

    
    // password section
    var $inputPwdCurrent = $('.inputCurrentPass').first();
    var $inputPwdNew = $('.inputNewPass').first();
    var $inputPwdConfirm = $('.inputСonfirmPass').first();

    var $changePassBut = $('.changePass').last();
    var passTextBoxTitle = $changeLoginBut.text();

    $inputPwdCurrent
        .add($inputPwdConfirm)
        .add($inputPwdNew)
        .keyup(function (event) {
            if (event.keyCode == 13)
                $changePassBut.trigger('click');
        });

    $changePassBut.click(function () {
        var pCurrent = $inputPwdCurrent.val();
        var pConfirm = $inputPwdConfirm.val();
        var pNew = $inputPwdNew.val();

        if (pCurrent.length < 5) {
            $inputPwdCurrent.focus();
            return;
        }

        if (pNew.length < 5) {
            $inputPwdNew.focus();
            return;
        }

        if (pNew !== pConfirm) {
            if (pConfirm.length)
                EventInspector.error('Пароли не совпадают!');
            $inputPwdConfirm.focus().val('');
            return;
        }

        $changePassBut.attr('disabled', 'disabled')
            .html('<i class="fa fa-circle-o-notch fa-spin"></i>');

        $.post(URLdir + 'handler/settings/changePassword', {
                'confirm_password': pConfirm,
                'old_password': pCurrent,
                'password': pNew
            }, function (data) {
                if (data.success) {
                    $changePassBut.text('Пароль изменен!');
                } else {
                    $changePassBut.text('Ошибка!').addClass('Error').removeAttr('disabled');
                }

                $inputPwdCurrent.focus()
                    .add($inputPwdConfirm)
                    .add($inputPwdNew)
                    .val('');

                setTimeout(function () {
                    $changePassBut.removeAttr('disabled')
                        .text(passTextBoxTitle)
                        .removeClass('Error');
                }, 1000);
            }, 'json'
        );
    });


    // email section
    $('.changeEmail').click(function () {
        //if (/^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,6})$/.test($('.inputNewEmail').val()))
        //    $.post(URLdir+'/handler/settings/changeEmail', {'email': $('.inputNewEmail').val()},
    });
}
